Linux 00830bc4dc40 5.4.0-204-generic #224-Ubuntu SMP Thu Dec 5 13:38:28 UTC 2024 x86_64
Apache/2.4
: 172.19.0.2 | : 216.73.217.74
Cant Read [ /etc/named.conf ]
7.4.33
flexusfire
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
2to3-2.7
96
B
-rwxr-xr-x
411toppm
9.87
KB
-rwxr-xr-x
[
58.34
KB
-rwxr-xr-x
aclocal
35.62
KB
-rwxr-xr-x
aclocal-1.16
35.62
KB
-rwxr-xr-x
addpart
30.23
KB
-rwxr-xr-x
addr2line
34.7
KB
-rwxr-xr-x
ambiguous_words
14.23
KB
-rwxr-xr-x
animate
14.15
KB
-rwxr-xr-x
animate-im6
14.15
KB
-rwxr-xr-x
animate-im6.q16
14.15
KB
-rwxr-xr-x
anytopnm
5.55
KB
-rwxr-xr-x
apt
18.38
KB
-rwxr-xr-x
apt-cache
86.46
KB
-rwxr-xr-x
apt-cdrom
30.46
KB
-rwxr-xr-x
apt-config
26.38
KB
-rwxr-xr-x
apt-get
46.46
KB
-rwxr-xr-x
apt-key
27.28
KB
-rwxr-xr-x
apt-mark
62.46
KB
-rwxr-xr-x
ar
66.43
KB
-rwxr-xr-x
arch
38.37
KB
-rwxr-xr-x
argon2
46.01
KB
-rwxr-xr-x
as
680.3
KB
-rwxr-xr-x
asciitopgm
9.87
KB
-rwxr-xr-x
atktopbm
17.87
KB
-rwxr-xr-x
autoconf
14.42
KB
-rwxr-xr-x
autoheader
8.34
KB
-rwxr-xr-x
autom4te
31.91
KB
-rwxr-xr-x
automake
251.9
KB
-rwxr-xr-x
automake-1.16
251.9
KB
-rwxr-xr-x
autoreconf
20.67
KB
-rwxr-xr-x
autoscan
16.73
KB
-rwxr-xr-x
autoupdate
33.08
KB
-rwxr-xr-x
awk
158.74
KB
-rwxr-xr-x
b2sum
58.37
KB
-rwxr-xr-x
base32
42.34
KB
-rwxr-xr-x
base64
42.34
KB
-rwxr-xr-x
basename
38.34
KB
-rwxr-xr-x
bash
1.13
MB
-rwxr-xr-x
bashbug
6.63
KB
-rwxr-xr-x
bioradtopgm
9.87
KB
-rwxr-xr-x
bmptopnm
13.91
KB
-rwxr-xr-x
bmptoppm
13.91
KB
-rwxr-xr-x
brushtopbm
9.87
KB
-rwxr-xr-x
bundle2.7
529
B
-rwxr-xr-x
bundler2.7
531
B
-rwxr-xr-x
bunzip2
38.23
KB
-rwxr-xr-x
bzcat
38.23
KB
-rwxr-xr-x
bzcmp
2.17
KB
-rwxr-xr-x
bzdiff
2.17
KB
-rwxr-xr-x
bzegrep
3.69
KB
-rwxr-xr-x
bzexe
4.76
KB
-rwxr-xr-x
bzfgrep
3.69
KB
-rwxr-xr-x
bzgrep
3.69
KB
-rwxr-xr-x
bzip2
38.23
KB
-rwxr-xr-x
bzip2recover
18.15
KB
-rwxr-xr-x
bzless
1.27
KB
-rwxr-xr-x
bzmore
1.27
KB
-rwxr-xr-x
c++
1.1
MB
-rwxr-xr-x
c++filt
30.27
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.65
KB
-rwxr-xr-x
captoinfo
90.41
KB
-rwxr-xr-x
cat
42.4
KB
-rwxr-xr-x
catchsegv
3.25
KB
-rwxr-xr-x
cautious-launcher
853
B
-rwxr-xr-x
cc
1.1
MB
-rwxr-xr-x
chage
82.53
KB
-rwxr-sr-x
chardet3
389
B
-rwxr-xr-x
chardetect3
389
B
-rwxr-xr-x
chattr
14.31
KB
-rwxr-xr-x
chcon
70.34
KB
-rwxr-xr-x
chfn
83.07
KB
-rwsr-xr-x
chgrp
70.34
KB
-rwxr-xr-x
chmod
62.37
KB
-rwxr-xr-x
choom
50.23
KB
-rwxr-xr-x
chown
70.34
KB
-rwxr-xr-x
chrt
38.23
KB
-rwxr-xr-x
chsh
51.8
KB
-rwsr-xr-x
cifsdd
90.92
KB
-rwxr-xr-x
cjpeg
46.23
KB
-rwxr-xr-x
cksum
38.34
KB
-rwxr-xr-x
classifier_tester
102.35
KB
-rwxr-xr-x
clear
14.31
KB
-rwxr-xr-x
clear_console
14.23
KB
-rwxr-xr-x
cmp
50.09
KB
-rwxr-xr-x
cmuwmtopbm
9.87
KB
-rwxr-xr-x
cntraining
102.35
KB
-rwxr-xr-x
combine_lang_model
118.31
KB
-rwxr-xr-x
combine_tessdata
18.31
KB
-rwxr-xr-x
comm
42.37
KB
-rwxr-xr-x
compare
14.15
KB
-rwxr-xr-x
compare-im6
14.15
KB
-rwxr-xr-x
compare-im6.q16
14.15
KB
-rwxr-xr-x
compose
18.05
KB
-rwxr-xr-x
composite
14.15
KB
-rwxr-xr-x
composite-im6
14.15
KB
-rwxr-xr-x
composite-im6.q16
14.15
KB
-rwxr-xr-x
conjure
14.15
KB
-rwxr-xr-x
conjure-im6
14.15
KB
-rwxr-xr-x
conjure-im6.q16
14.15
KB
-rwxr-xr-x
convert
14.15
KB
-rwxr-xr-x
convert-im6
14.15
KB
-rwxr-xr-x
convert-im6.q16
14.15
KB
-rwxr-xr-x
corelist
14.73
KB
-rwxr-xr-x
corepack
174
B
-rwxr-xr-x
cp
150.37
KB
-rwxr-xr-x
cpan
7.96
KB
-rwxr-xr-x
cpan5.30-x86_64-linux-gnu
7.98
KB
-rwxr-xr-x
cpp
1.1
MB
-rwxr-xr-x
cpp-9
1.1
MB
-rwxr-xr-x
csplit
54.37
KB
-rwxr-xr-x
curl
234.23
KB
-rwxr-xr-x
cut
46.37
KB
-rwxr-xr-x
cwebp
62.23
KB
-rwxr-xr-x
dash
126.77
KB
-rwxr-xr-x
date
106.37
KB
-rwxr-xr-x
dawg2wordlist
18.31
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.14
KB
-rwxr-xr-x
dbus-daemon
243.2
KB
-rwxr-xr-x
dbus-monitor
30.14
KB
-rwxr-xr-x
dbus-run-session
14.14
KB
-rwxr-xr-x
dbus-send
30.14
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.14
KB
-rwxr-xr-x
dbus-uuidgen
14.14
KB
-rwxr-xr-x
dbwrap_tool
26.52
KB
-rwxr-xr-x
dd
78.38
KB
-rwxr-xr-x
deb-systemd-helper
20.83
KB
-rwxr-xr-x
deb-systemd-invoke
4.33
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-set-selections
2.87
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
delpart
30.23
KB
-rwxr-xr-x
df
90.95
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_python2
1.03
KB
-rwxr-xr-x
diff
214.34
KB
-rwxr-xr-x
diff3
66.21
KB
-rwxr-xr-x
dir
138.81
KB
-rwxr-xr-x
dircolors
46.34
KB
-rwxr-xr-x
dirmngr
569.86
KB
-rwxr-xr-x
dirmngr-client
119.06
KB
-rwxr-xr-x
dirname
38.34
KB
-rwxr-xr-x
display
14.15
KB
-rwxr-xr-x
display-im6
14.15
KB
-rwxr-xr-x
display-im6.q16
14.15
KB
-rwxr-xr-x
djpeg
34.23
KB
-rwxr-xr-x
dmesg
82.46
KB
-rwxr-xr-x
dnsdomainname
26.23
KB
-rwxr-xr-x
domainname
26.23
KB
-rwxr-xr-x
dpkg
302.68
KB
-rwxr-xr-x
dpkg-architecture
12.55
KB
-rwxr-xr-x
dpkg-buildflags
7.39
KB
-rwxr-xr-x
dpkg-buildpackage
29.89
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
174.54
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
150.59
KB
-rwxr-xr-x
dpkg-genbuildinfo
16.4
KB
-rwxr-xr-x
dpkg-genchanges
17.08
KB
-rwxr-xr-x
dpkg-gencontrol
13.87
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.03
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.35
KB
-rwxr-xr-x
dpkg-name
6.63
KB
-rwxr-xr-x
dpkg-parsechangelog
4.46
KB
-rwxr-xr-x
dpkg-query
162.59
KB
-rwxr-xr-x
dpkg-scanpackages
8.49
KB
-rwxr-xr-x
dpkg-scansources
8.95
KB
-rwxr-xr-x
dpkg-shlibdeps
30.68
KB
-rwxr-xr-x
dpkg-source
22.48
KB
-rwxr-xr-x
dpkg-split
122.48
KB
-rwxr-xr-x
dpkg-statoverride
62.27
KB
-rwxr-xr-x
dpkg-trigger
82.49
KB
-rwxr-xr-x
dpkg-vendor
3.19
KB
-rwxr-xr-x
du
106.37
KB
-rwxr-xr-x
dumpelf
58.41
KB
-rwxr-xr-x
dvipdf
1007
B
-rwxr-xr-x
dwebp
34.23
KB
-rwxr-xr-x
dwp
1.95
MB
-rwxr-xr-x
echo
38.34
KB
-rwxr-xr-x
echo_supervisord_conf
419
B
-rwxr-xr-x
edit
18.05
KB
-rwxr-xr-x
egrep
28
B
-rwxr-xr-x
elfedit
42.67
KB
-rwxr-xr-x
enc2xs
41.12
KB
-rwxr-xr-x
encguess
2.99
KB
-rwxr-xr-x
env
42.34
KB
-rwxr-xr-x
eps2eps
639
B
-rwxr-xr-x
erb
4.94
KB
-rwxr-xr-x
erb2.7
4.94
KB
-rwxr-xr-x
exifautotran
1.11
KB
-rwxr-xr-x
expand
42.37
KB
-rwxr-xr-x
expiry
30.58
KB
-rwxr-sr-x
expr
54.34
KB
-rwxr-xr-x
eyuvtoppm
13.87
KB
-rwxr-xr-x
factor
78.37
KB
-rwxr-xr-x
faillog
22.59
KB
-rwxr-xr-x
faked-sysv
34.27
KB
-rwxr-xr-x
faked-tcp
34.25
KB
-rwxr-xr-x
fakeroot
3.76
KB
-rwxr-xr-x
fakeroot-sysv
3.76
KB
-rwxr-xr-x
fakeroot-tcp
3.76
KB
-rwxr-xr-x
fallocate
34.23
KB
-rwxr-xr-x
false
38.34
KB
-rwxr-xr-x
fc-cache
22.23
KB
-rwxr-xr-x
fc-cat
18.23
KB
-rwxr-xr-x
fc-conflist
14.23
KB
-rwxr-xr-x
fc-list
14.23
KB
-rwxr-xr-x
fc-match
14.23
KB
-rwxr-xr-x
fc-pattern
14.23
KB
-rwxr-xr-x
fc-query
14.23
KB
-rwxr-xr-x
fc-scan
14.23
KB
-rwxr-xr-x
fc-validate
14.23
KB
-rwxr-xr-x
ffmpeg
278.3
KB
-rwxr-xr-x
ffplay
142.32
KB
-rwxr-xr-x
ffprobe
170.49
KB
-rwxr-xr-x
fgrep
28
B
-rwxr-xr-x
fiascotopnm
114.45
KB
-rwxr-xr-x
file
26.47
KB
-rwxr-xr-x
fincore
34.27
KB
-rwxr-xr-x
find
312.66
KB
-rwxr-xr-x
findmnt
71.41
KB
-rwxr-xr-x
fitstopnm
13.87
KB
-rwxr-xr-x
flock
34.3
KB
-rwxr-xr-x
fmt
46.34
KB
-rwxr-xr-x
fold
42.34
KB
-rwxr-xr-x
free
26.23
KB
-rwxr-xr-x
fstopgm
9.87
KB
-rwxr-xr-x
funzip
26.15
KB
-rwxr-xr-x
g++
1.1
MB
-rwxr-xr-x
g++-9
1.1
MB
-rwxr-xr-x
g3topbm
12.98
KB
-rwxr-xr-x
gcc
1.1
MB
-rwxr-xr-x
gcc-9
1.1
MB
-rwxr-xr-x
gcc-ar
34.63
KB
-rwxr-xr-x
gcc-ar-9
34.63
KB
-rwxr-xr-x
gcc-nm
34.63
KB
-rwxr-xr-x
gcc-nm-9
34.63
KB
-rwxr-xr-x
gcc-ranlib
34.63
KB
-rwxr-xr-x
gcc-ranlib-9
34.63
KB
-rwxr-xr-x
gcov
656.23
KB
-rwxr-xr-x
gcov-9
656.23
KB
-rwxr-xr-x
gcov-dump
528.13
KB
-rwxr-xr-x
gcov-dump-9
528.13
KB
-rwxr-xr-x
gcov-tool
544.2
KB
-rwxr-xr-x
gcov-tool-9
544.2
KB
-rwxr-xr-x
gdk-pixbuf-csource
14.33
KB
-rwxr-xr-x
gdk-pixbuf-pixdata
14.31
KB
-rwxr-xr-x
gdk-pixbuf-thumbnailer
18.39
KB
-rwxr-xr-x
gem
545
B
-rwxr-xr-x
gem2.7
545
B
-rwxr-xr-x
gemtopbm
9.87
KB
-rwxr-xr-x
gemtopnm
9.87
KB
-rwxr-xr-x
gencat
26.37
KB
-rwxr-xr-x
getconf
34.29
KB
-rwxr-xr-x
getent
38.65
KB
-rwxr-xr-x
getopt
22.23
KB
-rwxr-xr-x
ghostscript
14.15
KB
-rwxr-xr-x
gif2webp
30.23
KB
-rwxr-xr-x
gifdiff
66.38
KB
-rwxr-xr-x
gifsicle
194.66
KB
-rwxr-xr-x
giftopnm
17.87
KB
-rwxr-xr-x
gifview
82.4
KB
-rwxr-xr-x
git
2.98
MB
-rwxr-xr-x
git-receive-pack
2.98
MB
-rwxr-xr-x
git-shell
1.71
MB
-rwxr-xr-x
git-upload-archive
2.98
MB
-rwxr-xr-x
git-upload-pack
2.98
MB
-rwxr-xr-x
gm
14.15
KB
-rwxr-xr-x
gold
2.21
MB
-rwxr-xr-x
gouldtoppm
9.87
KB
-rwxr-xr-x
gpasswd
86.39
KB
-rwsr-xr-x
gpg
1.02
MB
-rwxr-xr-x
gpg-agent
409.04
KB
-rwxr-xr-x
gpg-connect-agent
163.16
KB
-rwxr-xr-x
gpg-wks-server
203.2
KB
-rwxr-xr-x
gpg-zip
3.43
KB
-rwxr-xr-x
gpgcompose
878.29
KB
-rwxr-xr-x
gpgconf
174.66
KB
-rwxr-xr-x
gpgparsemail
34.38
KB
-rwxr-xr-x
gpgsm
507.24
KB
-rwxr-xr-x
gpgsplit
86.76
KB
-rwxr-xr-x
gpgtar
151.63
KB
-rwxr-xr-x
gpgv
447.15
KB
-rwxr-xr-x
gprof
99.88
KB
-rwxr-xr-x
grep
194.47
KB
-rwxr-xr-x
groups
38.34
KB
-rwxr-xr-x
gs
14.15
KB
-rwxr-xr-x
gsbj
350
B
-rwxr-xr-x
gsdj
352
B
-rwxr-xr-x
gsdj500
352
B
-rwxr-xr-x
gslj
353
B
-rwxr-xr-x
gslp
350
B
-rwxr-xr-x
gsnd
277
B
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
95.21
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.44
KB
-rwxr-xr-x
head
46.37
KB
-rwxr-xr-x
hipstopgm
9.87
KB
-rwxr-xr-x
hostid
38.34
KB
-rwxr-xr-x
hostname
26.23
KB
-rwxr-xr-x
htmldoc
413.01
KB
-rwxr-xr-x
i386
26.5
KB
-rwxr-xr-x
icontopbm
9.87
KB
-rwxr-xr-x
iconv
66.41
KB
-rwxr-xr-x
id
46.37
KB
-rwxr-xr-x
identify
14.15
KB
-rwxr-xr-x
identify-im6
14.15
KB
-rwxr-xr-x
identify-im6.q16
14.15
KB
-rwxr-xr-x
ifnames
4.03
KB
-rwxr-xr-x
ilbmtoppm
77.95
KB
-rwxr-xr-x
imagetops
1.21
KB
-rwxr-xr-x
img2webp
46.23
KB
-rwxr-xr-x
imgtoppm
9.87
KB
-rwxr-xr-x
import
14.15
KB
-rwxr-xr-x
import-im6
14.15
KB
-rwxr-xr-x
import-im6.q16
14.15
KB
-rwxr-xr-x
infocmp
62.38
KB
-rwxr-xr-x
infotocap
90.41
KB
-rwxr-xr-x
install
154.41
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
30.23
KB
-rwxr-xr-x
ipcmk
34.3
KB
-rwxr-xr-x
ipcrm
34.23
KB
-rwxr-xr-x
ipcs
66.23
KB
-rwxr-xr-x
irb
507
B
-rwxr-xr-x
irb2.7
507
B
-rwxr-xr-x
ischroot
14.2
KB
-rwxr-xr-x
isql
91.54
KB
-rwxr-xr-x
iusql
65.4
KB
-rwxr-xr-x
java
14.19
KB
-rwxr-xr-x
jexec
14.18
KB
-rwxr-xr-x
jjs
14.23
KB
-rwxr-xr-x
join
54.37
KB
-rwxr-xr-x
jpegexiforient
14.15
KB
-rwxr-xr-x
jpegoptim
38.89
KB
-rwxr-xr-x
jpegtopnm
29.95
KB
-rwxr-xr-x
jpegtran
46.15
KB
-rwxr-xr-x
json_pp
4.56
KB
-rwxr-xr-x
kbxutil
174.97
KB
-rwxr-xr-x
keytool
14.2
KB
-rwxr-xr-x
kill
30.23
KB
-rwxr-xr-x
last
50.23
KB
-rwxr-xr-x
lastb
50.23
KB
-rwxr-xr-x
lastlog
31.66
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.65
MB
-rwxr-xr-x
ld.bfd
1.65
MB
-rwxr-xr-x
ld.gold
2.21
MB
-rwxr-xr-x
ldd
5.3
KB
-rwxr-xr-x
lddtree
6.34
KB
-rwxr-xr-x
leaftoppm
9.87
KB
-rwxr-xr-x
less
175.84
KB
-rwxr-xr-x
lessecho
14.31
KB
-rwxr-xr-x
lessfile
8.36
KB
-rwxr-xr-x
lesskey
23.72
KB
-rwxr-xr-x
lesspipe
8.36
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
128.25
KB
-rwxr-xr-x
link
38.34
KB
-rwxr-xr-x
linux32
26.5
KB
-rwxr-xr-x
linux64
26.5
KB
-rwxr-xr-x
lispmtopgm
9.87
KB
-rwxr-xr-x
ln
74.38
KB
-rwxr-xr-x
locale
57.56
KB
-rwxr-xr-x
locale-check
14.16
KB
-rwxr-xr-x
localedef
326.96
KB
-rwxr-xr-x
logger
50.82
KB
-rwxr-xr-x
login
55.77
KB
-rwxr-xr-x
logname
38.34
KB
-rwxr-xr-x
ls
138.81
KB
-rwxr-xr-x
lsattr
14.31
KB
-rwxr-xr-x
lsblk
130.23
KB
-rwxr-xr-x
lscpu
98.23
KB
-rwxr-xr-x
lsipc
94.23
KB
-rwxr-xr-x
lslocks
38.55
KB
-rwxr-xr-x
lslogins
66.23
KB
-rwxr-xr-x
lsmem
66.23
KB
-rwxr-xr-x
lsns
50.23
KB
-rwxr-xr-x
lspgpot
1.06
KB
-rwxr-xr-x
lstmeval
118.35
KB
-rwxr-xr-x
lstmtraining
130.35
KB
-rwxr-xr-x
lzcat
78.5
KB
-rwxr-xr-x
lzcmp
6.48
KB
-rwxr-xr-x
lzdiff
6.48
KB
-rwxr-xr-x
lzegrep
5.76
KB
-rwxr-xr-x
lzfgrep
5.76
KB
-rwxr-xr-x
lzgrep
5.76
KB
-rwxr-xr-x
lzless
1.76
KB
-rwxr-xr-x
lzma
78.5
KB
-rwxr-xr-x
lzmainfo
14.23
KB
-rwxr-xr-x
lzmore
2.11
KB
-rwxr-xr-x
m4
158.45
KB
-rwxr-xr-x
macptopbm
9.87
KB
-rwxr-xr-x
make
225.55
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
man
320
B
-rwxr-xr-x
mawk
158.74
KB
-rwxr-xr-x
mcookie
34.3
KB
-rwxr-xr-x
md5sum
46.37
KB
-rwxr-xr-x
md5sum.textutils
46.37
KB
-rwxr-xr-x
mdatopbm
9.87
KB
-rwxr-xr-x
mdsearch
86.3
KB
-rwxr-xr-x
merge_unicharsets
14.23
KB
-rwxr-xr-x
mesa-overlay-control.py
5.67
KB
-rwxr-xr-x
mesg
14.23
KB
-rwxr-xr-x
mftraining
118.35
KB
-rwxr-xr-x
mgrtopbm
9.87
KB
-rwxr-xr-x
migrate-pubring-from-classic-g...
2.99
KB
-rwxr-xr-x
mkdir
86.34
KB
-rwxr-xr-x
mkfifo
66.34
KB
-rwxr-xr-x
mknod
70.34
KB
-rwxr-xr-x
mktemp
46.34
KB
-rwxr-xr-x
mlock
14.15
KB
-rwxr-sr-x
mogrify
14.15
KB
-rwxr-xr-x
mogrify-im6
14.15
KB
-rwxr-xr-x
mogrify-im6.q16
14.15
KB
-rwxr-xr-x
montage
14.15
KB
-rwxr-xr-x
montage-im6
14.15
KB
-rwxr-xr-x
montage-im6.q16
14.15
KB
-rwxr-xr-x
more
42.15
KB
-rwxr-xr-x
mount
54.23
KB
-rwsr-xr-x
mountpoint
14.23
KB
-rwxr-xr-x
mtrace
6.35
KB
-rwxr-xr-x
mtvtoppm
9.87
KB
-rwxr-xr-x
mv
146.38
KB
-rwxr-xr-x
myisam_ftdump
6.58
MB
-rwxr-xr-x
mysql
7.33
MB
-rwxr-xr-x
mysql_config_editor
6.31
MB
-rwxr-xr-x
mysqladmin
7.17
MB
-rwxr-xr-x
mysqlanalyze
7.18
MB
-rwxr-xr-x
mysqlcheck
7.18
MB
-rwxr-xr-x
mysqldump
7.25
MB
-rwxr-xr-x
mysqldumpslow
7.54
KB
-rwxr-xr-x
mysqlimport
7.17
MB
-rwxr-xr-x
mysqloptimize
7.18
MB
-rwxr-xr-x
mysqlpump
7.6
MB
-rwxr-xr-x
mysqlrepair
7.18
MB
-rwxr-xr-x
mysqlreport
38.1
KB
-rwxr-xr-x
mysqlshow
7.17
MB
-rwxr-xr-x
mysqlslap
7.18
MB
-rwxr-xr-x
namei
34.23
KB
-rwxr-xr-x
nawk
158.74
KB
-rwxr-xr-x
nc
42.64
KB
-rwxr-xr-x
nc.openbsd
42.64
KB
-rwxr-xr-x
neotoppm
9.87
KB
-rwxr-xr-x
net
975.24
KB
-rwxr-xr-x
netcat
42.64
KB
-rwxr-xr-x
newgrp
43.73
KB
-rwsr-xr-x
nice
42.34
KB
-rwxr-xr-x
nisdomainname
26.23
KB
-rwxr-xr-x
nl
42.43
KB
-rwxr-xr-x
nm
51.43
KB
-rwxr-xr-x
nmblookup
146.47
KB
-rwxr-xr-x
node
115.88
MB
-rwxr-xr-x
nodejs
115.88
MB
-rwxr-xr-x
nohup
42.34
KB
-rwxr-xr-x
npm
54
B
-rwxr-xr-x
nproc
42.34
KB
-rwxr-xr-x
npx
2.85
KB
-rwxr-xr-x
nsenter
34.43
KB
-rwxr-xr-x
numfmt
66.4
KB
-rwxr-xr-x
objcopy
182.48
KB
-rwxr-xr-x
objdump
392.83
KB
-rwxr-xr-x
od
70.37
KB
-rwxr-xr-x
odbcinst
43.52
KB
-rwxr-xr-x
openssl
735.68
KB
-rwxr-xr-x
optipng
94.11
KB
-rwxr-xr-x
pack200
14.2
KB
-rwxr-xr-x
pager
175.84
KB
-rwxr-xr-x
palmtopnm
17.87
KB
-rwxr-xr-x
pamcut
13.87
KB
-rwxr-xr-x
pamdeinterlace
9.87
KB
-rwxr-xr-x
pamdice
9.87
KB
-rwxr-xr-x
pamfile
9.87
KB
-rwxr-xr-x
pamoil
9.87
KB
-rwxr-xr-x
pamstack
9.87
KB
-rwxr-xr-x
pamstretch
13.87
KB
-rwxr-xr-x
pamstretch-gen
1.31
KB
-rwxr-xr-x
paperconf
13.99
KB
-rwxr-xr-x
partx
118.23
KB
-rwxr-xr-x
passwd
66.61
KB
-rwsr-xr-x
paste
42.37
KB
-rwxr-xr-x
patch
190.52
KB
-rwxr-xr-x
pathchk
38.34
KB
-rwxr-xr-x
pbmclean
9.87
KB
-rwxr-xr-x
pbmlife
9.87
KB
-rwxr-xr-x
pbmmake
9.87
KB
-rwxr-xr-x
pbmmask
9.87
KB
-rwxr-xr-x
pbmpage
9.87
KB
-rwxr-xr-x
pbmpscale
9.98
KB
-rwxr-xr-x
pbmreduce
9.87
KB
-rwxr-xr-x
pbmtext
9.87
KB
-rwxr-xr-x
pbmtextps
13.87
KB
-rwxr-xr-x
pbmto10x
9.87
KB
-rwxr-xr-x
pbmtoascii
10.14
KB
-rwxr-xr-x
pbmtoatk
9.87
KB
-rwxr-xr-x
pbmtobbnbg
9.87
KB
-rwxr-xr-x
pbmtocmuwm
9.87
KB
-rwxr-xr-x
pbmtoepsi
9.87
KB
-rwxr-xr-x
pbmtoepson
9.87
KB
-rwxr-xr-x
pbmtog3
12.98
KB
-rwxr-xr-x
pbmtogem
9.87
KB
-rwxr-xr-x
pbmtogo
9.87
KB
-rwxr-xr-x
pbmtoicon
9.87
KB
-rwxr-xr-x
pbmtolj
13.88
KB
-rwxr-xr-x
pbmtomacp
9.87
KB
-rwxr-xr-x
pbmtomda
9.87
KB
-rwxr-xr-x
pbmtomgr
9.87
KB
-rwxr-xr-x
pbmtonokia
9.87
KB
-rwxr-xr-x
pbmtopgm
9.87
KB
-rwxr-xr-x
pbmtopi3
9.87
KB
-rwxr-xr-x
pbmtoplot
9.87
KB
-rwxr-xr-x
pbmtoppa
33.88
KB
-rwxr-xr-x
pbmtopsg3
11.51
KB
-rwxr-xr-x
pbmtoptx
9.87
KB
-rwxr-xr-x
pbmtowbmp
9.87
KB
-rwxr-xr-x
pbmtox10bm
9.87
KB
-rwxr-xr-x
pbmtoxbm
9.87
KB
-rwxr-xr-x
pbmtoybm
9.87
KB
-rwxr-xr-x
pbmtozinc
9.87
KB
-rwxr-xr-x
pbmupc
17.87
KB
-rwxr-xr-x
pcxtoppm
17.87
KB
-rwxr-xr-x
pdb2
45.02
KB
-rwxr-xr-x
pdb2.7
45.02
KB
-rwxr-xr-x
pdb3
61.27
KB
-rwxr-xr-x
pdb3.8
61.27
KB
-rwxr-xr-x
pdf2dsc
698
B
-rwxr-xr-x
pdf2ps
909
B
-rwxr-xr-x
pdftk
21.92
MB
-rwxr-xr-x
perl
3.32
MB
-rwxr-xr-x
perl5.30-x86_64-linux-gnu
14.3
KB
-rwxr-xr-x
perl5.30.0
3.32
MB
-rwxr-xr-x
perlbug
45.28
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
45.28
KB
-rwxr-xr-x
pf2afm
498
B
-rwxr-xr-x
pfbtopfa
516
B
-rwxr-xr-x
pgmbentley
5.87
KB
-rwxr-xr-x
pgmcrater
13.9
KB
-rwxr-xr-x
pgmedge
9.87
KB
-rwxr-xr-x
pgmenhance
9.87
KB
-rwxr-xr-x
pgmhist
9.87
KB
-rwxr-xr-x
pgmkernel
9.87
KB
-rwxr-xr-x
pgmnoise
9.87
KB
-rwxr-xr-x
pgmnorm
9.87
KB
-rwxr-xr-x
pgmoil
9.87
KB
-rwxr-xr-x
pgmramp
9.87
KB
-rwxr-xr-x
pgmslice
9.87
KB
-rwxr-xr-x
pgmtexture
25.87
KB
-rwxr-xr-x
pgmtofs
9.87
KB
-rwxr-xr-x
pgmtolispm
9.87
KB
-rwxr-xr-x
pgmtopbm
16.29
KB
-rwxr-xr-x
pgmtoppm
9.87
KB
-rwxr-xr-x
pgrep
30.24
KB
-rwxr-xr-x
pi1toppm
9.87
KB
-rwxr-xr-x
pi3topbm
9.87
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.38
KB
-rwxr-xr-x
pidproxy
393
B
-rwxr-xr-x
pinentry
66.64
KB
-rwxr-xr-x
pinentry-curses
66.64
KB
-rwxr-xr-x
pinky
42.37
KB
-rwxr-xr-x
pip
365
B
-rwxr-xr-x
pip3
367
B
-rwxr-xr-x
pjtoppm
13.88
KB
-rwxr-xr-x
pkill
30.24
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.37
KB
-rwxr-xr-x
pmap
34.24
KB
-rwxr-xr-x
pngcrush
115.39
KB
-rwxr-xr-x
pngout
88.63
KB
-rwxr-xr-x
pngquant
38.07
KB
-rwxr-xr-x
pngtopnm
21.95
KB
-rwxr-xr-x
pnmalias
13.87
KB
-rwxr-xr-x
pnmarith
9.87
KB
-rwxr-xr-x
pnmcat
9.87
KB
-rwxr-xr-x
pnmcolormap
13.87
KB
-rwxr-xr-x
pnmcomp
9.87
KB
-rwxr-xr-x
pnmconvol
37.87
KB
-rwxr-xr-x
pnmcrop
13.87
KB
-rwxr-xr-x
pnmcut
13.87
KB
-rwxr-xr-x
pnmdepth
9.87
KB
-rwxr-xr-x
pnmenlarge
9.87
KB
-rwxr-xr-x
pnmfile
9.87
KB
-rwxr-xr-x
pnmflip
9.87
KB
-rwxr-xr-x
pnmgamma
13.87
KB
-rwxr-xr-x
pnmhisteq
9.87
KB
-rwxr-xr-x
pnmhistmap
9.88
KB
-rwxr-xr-x
pnmindex
4.49
KB
-rwxr-xr-x
pnminterp
13.87
KB
-rwxr-xr-x
pnminterp-gen
1.31
KB
-rwxr-xr-x
pnminvert
9.87
KB
-rwxr-xr-x
pnmmargin
1.73
KB
-rwxr-xr-x
pnmmontage
13.88
KB
-rwxr-xr-x
pnmnlfilt
21.93
KB
-rwxr-xr-x
pnmnoraw
9.87
KB
-rwxr-xr-x
pnmnorm
9.87
KB
-rwxr-xr-x
pnmpad
9.87
KB
-rwxr-xr-x
pnmpaste
9.87
KB
-rwxr-xr-x
pnmpsnr
9.87
KB
-rwxr-xr-x
pnmquant
3.13
KB
-rwxr-xr-x
pnmremap
17.87
KB
-rwxr-xr-x
pnmrotate
13.87
KB
-rwxr-xr-x
pnmscale
17.87
KB
-rwxr-xr-x
pnmscalefixed
13.87
KB
-rwxr-xr-x
pnmshear
9.87
KB
-rwxr-xr-x
pnmsmooth
9.87
KB
-rwxr-xr-x
pnmsplit
9.87
KB
-rwxr-xr-x
pnmtile
9.87
KB
-rwxr-xr-x
pnmtoddif
13.87
KB
-rwxr-xr-x
pnmtofiasco
199.9
KB
-rwxr-xr-x
pnmtofits
9.87
KB
-rwxr-xr-x
pnmtojpeg
17.87
KB
-rwxr-xr-x
pnmtopalm
17.87
KB
-rwxr-xr-x
pnmtoplainpnm
9.87
KB
-rwxr-xr-x
pnmtopng
29.93
KB
-rwxr-xr-x
pnmtops
17.87
KB
-rwxr-xr-x
pnmtorast
9.87
KB
-rwxr-xr-x
pnmtorle
38.15
KB
-rwxr-xr-x
pnmtosgi
13.87
KB
-rwxr-xr-x
pnmtosir
9.87
KB
-rwxr-xr-x
pnmtotiff
17.87
KB
-rwxr-xr-x
pnmtotiffcmyk
17.87
KB
-rwxr-xr-x
pnmtoxwd
9.87
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.68
KB
-rwxr-xr-x
pod2text
10.55
KB
-rwxr-xr-x
pod2usage
3.86
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
podselect
2.47
KB
-rwxr-xr-x
pphs
404
B
-rwxr-xr-x
ppm3d
13.87
KB
-rwxr-xr-x
ppmbrighten
9.87
KB
-rwxr-xr-x
ppmchange
9.87
KB
-rwxr-xr-x
ppmcie
26.04
KB
-rwxr-xr-x
ppmcolormask
9.87
KB
-rwxr-xr-x
ppmcolors
9.87
KB
-rwxr-xr-x
ppmdim
9.87
KB
-rwxr-xr-x
ppmdist
9.87
KB
-rwxr-xr-x
ppmdither
9.87
KB
-rwxr-xr-x
ppmfade
11.39
KB
-rwxr-xr-x
ppmflash
9.87
KB
-rwxr-xr-x
ppmforge
21.88
KB
-rwxr-xr-x
ppmhist
9.87
KB
-rwxr-xr-x
ppmlabel
9.87
KB
-rwxr-xr-x
ppmmake
9.87
KB
-rwxr-xr-x
ppmmix
9.87
KB
-rwxr-xr-x
ppmnorm
9.87
KB
-rwxr-xr-x
ppmntsc
13.88
KB
-rwxr-xr-x
ppmpat
21.87
KB
-rwxr-xr-x
ppmquant
17.87
KB
-rwxr-xr-x
ppmquantall
2.02
KB
-rwxr-xr-x
ppmqvga
13.87
KB
-rwxr-xr-x
ppmrainbow
1.67
KB
-rwxr-xr-x
ppmrelief
9.87
KB
-rwxr-xr-x
ppmshadow
6.67
KB
-rwxr-xr-x
ppmshift
9.87
KB
-rwxr-xr-x
ppmspread
9.87
KB
-rwxr-xr-x
ppmtoacad
14.72
KB
-rwxr-xr-x
ppmtobmp
13.92
KB
-rwxr-xr-x
ppmtoeyuv
9.87
KB
-rwxr-xr-x
ppmtogif
17.88
KB
-rwxr-xr-x
ppmtoicr
9.87
KB
-rwxr-xr-x
ppmtoilbm
37.96
KB
-rwxr-xr-x
ppmtojpeg
17.87
KB
-rwxr-xr-x
ppmtoleaf
9.87
KB
-rwxr-xr-x
ppmtolj
9.87
KB
-rwxr-xr-x
ppmtomap
81
B
-rwxr-xr-x
ppmtomitsu
17.87
KB
-rwxr-xr-x
ppmtompeg
549.78
KB
-rwxr-xr-x
ppmtoneo
9.87
KB
-rwxr-xr-x
ppmtopcx
13.87
KB
-rwxr-xr-x
ppmtopgm
9.87
KB
-rwxr-xr-x
ppmtopi1
9.87
KB
-rwxr-xr-x
ppmtopict
9.87
KB
-rwxr-xr-x
ppmtopj
9.87
KB
-rwxr-xr-x
ppmtopuzz
9.87
KB
-rwxr-xr-x
ppmtorgb3
9.87
KB
-rwxr-xr-x
ppmtosixel
9.87
KB
-rwxr-xr-x
ppmtotga
13.87
KB
-rwxr-xr-x
ppmtouil
9.87
KB
-rwxr-xr-x
ppmtowinicon
17.89
KB
-rwxr-xr-x
ppmtoxpm
13.87
KB
-rwxr-xr-x
ppmtoyuv
9.87
KB
-rwxr-xr-x
ppmtoyuvsplit
9.87
KB
-rwxr-xr-x
ppmtv
9.87
KB
-rwxr-xr-x
pr
74.43
KB
-rwxr-xr-x
print
18.05
KB
-rwxr-xr-x
printafm
395
B
-rwxr-xr-x
printenv
38.34
KB
-rwxr-xr-x
printf
58.34
KB
-rwxr-xr-x
prlimit
38.74
KB
-rwxr-xr-x
prove
13.33
KB
-rwxr-xr-x
ps
134.46
KB
-rwxr-xr-x
ps2ascii
631
B
-rwxr-xr-x
ps2epsi
2.69
KB
-rwxr-xr-x
ps2pdf
272
B
-rwxr-xr-x
ps2pdf12
215
B
-rwxr-xr-x
ps2pdf13
215
B
-rwxr-xr-x
ps2pdf14
215
B
-rwxr-xr-x
ps2pdfwr
1.05
KB
-rwxr-xr-x
ps2ps
647
B
-rwxr-xr-x
ps2ps2
669
B
-rwxr-xr-x
ps2txt
631
B
-rwxr-xr-x
psidtopgm
9.87
KB
-rwxr-xr-x
pspax
50.41
KB
-rwxr-xr-x
pstopnm
17.87
KB
-rwxr-xr-x
ptar
3.47
KB
-rwxr-xr-x
ptardiff
2.57
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
78.4
KB
-rwxr-xr-x
pwd
42.34
KB
-rwxr-xr-x
pwdx
14.23
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
11.84
KB
-rwxr-xr-x
py3versions
11.44
KB
-rwxr-xr-x
pyclean
4.03
KB
-rwxr-xr-x
pycompile
11.62
KB
-rwxr-xr-x
pydoc2
79
B
-rwxr-xr-x
pydoc2.7
79
B
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.8
79
B
-rwxr-xr-x
pygettext2
21.56
KB
-rwxr-xr-x
pygettext2.7
21.56
KB
-rwxr-xr-x
pygettext3
21.03
KB
-rwxr-xr-x
pygettext3.8
21.03
KB
-rwxr-xr-x
python
3.49
MB
-rwxr-xr-x
python2
3.49
MB
-rwxr-xr-x
python2.7
3.49
MB
-rwxr-xr-x
python3
5.24
MB
-rwxr-xr-x
python3-config
3.17
KB
-rwxr-xr-x
python3.8
5.24
MB
-rwxr-xr-x
python3.8-config
3.17
KB
-rwxr-xr-x
pyversions
14.76
KB
-rwxr-xr-x
qrttoppm
9.87
KB
-rwxr-xr-x
qt-faststart
18.15
KB
-rwxr-xr-x
racc2.7
586
B
-rwxr-xr-x
racc2y2.7
590
B
-rwxr-xr-x
rake
510
B
-rwxr-xr-x
ranlib
66.46
KB
-rwxr-xr-x
rasttopnm
13.87
KB
-rwxr-xr-x
rawtopgm
9.87
KB
-rwxr-xr-x
rawtoppm
9.87
KB
-rwxr-xr-x
rbash
1.13
MB
-rwxr-xr-x
rcp
114.3
KB
-rwxr-xr-x
rdjpgcom
14.15
KB
-rwxr-xr-x
rdoc
513
B
-rwxr-xr-x
rdoc2.7
513
B
-rwxr-xr-x
readelf
642.93
KB
-rwxr-xr-x
readlink
50.34
KB
-rwxr-xr-x
realpath
50.37
KB
-rwxr-xr-x
rename.ul
22.23
KB
-rwxr-xr-x
renice
14.23
KB
-rwxr-xr-x
reset
30.31
KB
-rwxr-xr-x
resizepart
62.23
KB
-rwxr-xr-x
rev
14.23
KB
-rwxr-xr-x
rgb3toppm
9.87
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
ri
509
B
-rwxr-xr-x
ri2.7
509
B
-rwxr-xr-x
rletopnm
34.12
KB
-rwxr-xr-x
rlogin
774.95
KB
-rwxr-xr-x
rm
70.37
KB
-rwxr-xr-x
rmdir
46.34
KB
-rwxr-xr-x
rmid
14.2
KB
-rwxr-xr-x
rmiregistry
14.21
KB
-rwxr-xr-x
rpcclient
1.32
MB
-rwxr-xr-x
rpcgen
98.69
KB
-rwxr-xr-x
rsh
774.95
KB
-rwxr-xr-x
ruby
14.15
KB
-rwxr-xr-x
ruby2.7
14.15
KB
-rwxr-xr-x
run-mailcap
18.05
KB
-rwxr-xr-x
run-parts
26.51
KB
-rwxr-xr-x
runcon
38.34
KB
-rwxr-xr-x
samba-regedit
111.24
KB
-rwxr-xr-x
samba-tool
1.52
KB
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
sbigtopgm
9.96
KB
-rwxr-xr-x
scanelf
106.41
KB
-rwxr-xr-x
scanmacho
38.41
KB
-rwxr-xr-x
scp
114.3
KB
-rwxr-xr-x
script
54.23
KB
-rwxr-xr-x
scriptreplay
30.23
KB
-rwxr-xr-x
sdiff
50.09
KB
-rwxr-xr-x
sed
118.45
KB
-rwxr-xr-x
see
18.05
KB
-rwxr-xr-x
select-editor
2.38
KB
-rwxr-xr-x
sensible-browser
1.2
KB
-rwxr-xr-x
sensible-editor
1.14
KB
-rwxr-xr-x
sensible-pager
452
B
-rwxr-xr-x
seq
50.34
KB
-rwxr-xr-x
set_unicharset_properties
174.35
KB
-rwxr-xr-x
setarch
26.5
KB
-rwxr-xr-x
setpriv
46.23
KB
-rwxr-xr-x
setsid
14.23
KB
-rwxr-xr-x
setterm
46.23
KB
-rwxr-xr-x
sftp
166.51
KB
-rwxr-xr-x
sg
43.73
KB
-rwsr-xr-x
sgitopnm
13.87
KB
-rwxr-xr-x
sh
126.77
KB
-rwxr-xr-x
sha1sum
50.37
KB
-rwxr-xr-x
sha224sum
58.37
KB
-rwxr-xr-x
sha256sum
58.37
KB
-rwxr-xr-x
sha384sum
66.37
KB
-rwxr-xr-x
sha512sum
66.37
KB
-rwxr-xr-x
shapeclustering
102.35
KB
-rwxr-xr-x
shasum
9.74
KB
-rwxr-xr-x
shred
62.37
KB
-rwxr-xr-x
shuf
58.34
KB
-rwxr-xr-x
sirtopnm
9.87
KB
-rwxr-xr-x
size
34.45
KB
-rwxr-xr-x
skill
30.23
KB
-rwxr-xr-x
slabtop
22.23
KB
-rwxr-xr-x
sldtoppm
17.94
KB
-rwxr-xr-x
sleep
38.34
KB
-rwxr-xr-x
slogin
774.95
KB
-rwxr-xr-x
smbcacls
54.38
KB
-rwxr-xr-x
smbclient
154.48
KB
-rwxr-xr-x
smbcquotas
34.3
KB
-rwxr-xr-x
smbget
30.39
KB
-rwxr-xr-x
smbpasswd
38.3
KB
-rwxr-xr-x
smbspool
26.3
KB
-rwxr-xr-x
smbtar
4.81
KB
-rwxr-xr-x
smbtree
22.3
KB
-rwxr-xr-x
snice
30.23
KB
-rwxr-xr-x
sort
114.63
KB
-rwxr-xr-x
sotruss
4.21
KB
-rwxr-xr-x
spctoppm
9.87
KB
-rwxr-xr-x
splain
18.7
KB
-rwxr-xr-x
split
58.77
KB
-rwxr-xr-x
sprof
34.37
KB
-rwxr-xr-x
sputoppm
9.87
KB
-rwxr-xr-x
ssh
774.95
KB
-rwxr-xr-x
ssh-add
362.28
KB
-rwxr-xr-x
ssh-agent
342.29
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
10.41
KB
-rwxr-xr-x
ssh-keygen
466.3
KB
-rwxr-xr-x
ssh-keyscan
454.3
KB
-rwxr-xr-x
st4topgm
9.87
KB
-rwxr-xr-x
stat
86.37
KB
-rwxr-xr-x
stdbuf
50.34
KB
-rwxr-xr-x
stream
14.15
KB
-rwxr-xr-x
stream-im6
14.15
KB
-rwxr-xr-x
stream-im6.q16
14.15
KB
-rwxr-xr-x
strings
34.66
KB
-rwxr-xr-x
strip
182.48
KB
-rwxr-xr-x
stty
82.37
KB
-rwxr-xr-x
su
66.23
KB
-rwsr-xr-x
sum
46.34
KB
-rwxr-xr-x
supervisorctl
403
B
-rwxr-xr-x
supervisord
399
B
-rwxr-xr-x
symcryptrun
123.03
KB
-rwxr-xr-x
symtree
1.98
KB
-rwxr-xr-x
sync
38.34
KB
-rwxr-xr-x
tabs
18.3
KB
-rwxr-xr-x
tac
42.34
KB
-rwxr-xr-x
tail
70.4
KB
-rwxr-xr-x
tar
437.61
KB
-rwxr-xr-x
taskset
34.23
KB
-rwxr-xr-x
tee
42.37
KB
-rwxr-xr-x
tempfile
14.02
KB
-rwxr-xr-x
tesseract
34.23
KB
-rwxr-xr-x
test
54.34
KB
-rwxr-xr-x
testparm
42.3
KB
-rwxr-xr-x
text2image
210.38
KB
-rwxr-xr-x
tgatoppm
13.87
KB
-rwxr-xr-x
thinkjettopbm
17.88
KB
-rwxr-xr-x
tic
90.41
KB
-rwxr-xr-x
tifftopnm
17.87
KB
-rwxr-xr-x
timeout
42.77
KB
-rwxr-xr-x
tload
22.24
KB
-rwxr-xr-x
toe
22.3
KB
-rwxr-xr-x
top
126.05
KB
-rwxr-xr-x
touch
98.37
KB
-rwxr-xr-x
tput
26.34
KB
-rwxr-xr-x
tr
50.34
KB
-rwxr-xr-x
true
38.34
KB
-rwxr-xr-x
truncate
42.34
KB
-rwxr-xr-x
tset
30.31
KB
-rwxr-xr-x
tsort
42.34
KB
-rwxr-xr-x
tty
38.34
KB
-rwxr-xr-x
tzselect
15.02
KB
-rwxr-xr-x
ucf
39.73
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.47
KB
-rwxr-xr-x
umount
38.23
KB
-rwsr-xr-x
uname
38.37
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
42.37
KB
-rwxr-xr-x
unicharset_extractor
114.31
KB
-rwxr-xr-x
uniq
50.37
KB
-rwxr-xr-x
unlink
38.34
KB
-rwxr-xr-x
unlzma
78.5
KB
-rwxr-xr-x
unpack200
113.02
KB
-rwxr-xr-x
unshare
42.43
KB
-rwxr-xr-x
unxz
78.5
KB
-rwxr-xr-x
unzip
182.29
KB
-rwxr-xr-x
unzipsfx
82.27
KB
-rwxr-xr-x
update-alternatives
54.41
KB
-rwxr-xr-x
update-mime-database
58.37
KB
-rwxr-xr-x
uptime
14.23
KB
-rwxr-xr-x
users
38.34
KB
-rwxr-xr-x
utmpdump
30.23
KB
-rwxr-xr-x
vdir
138.81
KB
-rwxr-xr-x
vmstat
38.25
KB
-rwxr-xr-x
vwebp
30.15
KB
-rwxr-xr-x
w
22.23
KB
-rwxr-xr-x
w.procps
22.23
KB
-rwxr-xr-x
wall
34.23
KB
-rwxr-xr-x
watch
26.57
KB
-rwxr-xr-x
watchgnupg
18.3
KB
-rwxr-xr-x
wbmptopbm
9.87
KB
-rwxr-xr-x
wc
46.34
KB
-rwxr-xr-x
wdctl
34.23
KB
-rwxr-xr-x
webpinfo
30.23
KB
-rwxr-xr-x
webpmux
34.23
KB
-rwxr-xr-x
wget
531.71
KB
-rwxr-xr-x
whereis
34.66
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
who
58.37
KB
-rwxr-xr-x
whoami
38.34
KB
-rwxr-xr-x
winicontoppm
17.87
KB
-rwxr-xr-x
wordlist2dawg
22.31
KB
-rwxr-xr-x
wrjpgcom
14.15
KB
-rwxr-xr-x
x86_64
26.5
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
34.7
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
66.43
KB
-rwxr-xr-x
x86_64-linux-gnu-as
680.3
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
30.27
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
1.95
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
42.67
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-9
1.1
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-9
34.63
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
656.23
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-9
656.23
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
528.13
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-9
528.13
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
544.2
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-9
544.2
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.21
MB
-rwxr-xr-x
x86_64-linux-gnu-gprof
99.88
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.65
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.65
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.21
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
51.43
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
182.48
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
392.83
KB
-rwxr-xr-x
x86_64-linux-gnu-python3-confi...
3.17
KB
-rwxr-xr-x
x86_64-linux-gnu-python3.8-con...
3.17
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
66.46
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
642.93
KB
-rwxr-xr-x
x86_64-linux-gnu-size
34.45
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
34.66
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
182.48
KB
-rwxr-xr-x
xargs
74.37
KB
-rwxr-xr-x
xauth
54.97
KB
-rwxr-xr-x
xbmtopbm
9.87
KB
-rwxr-xr-x
xdg-user-dir
234
B
-rwxr-xr-x
xdg-user-dirs-update
26.07
KB
-rwxr-xr-x
ximtoppm
13.87
KB
-rwxr-xr-x
xpmtoppm
17.92
KB
-rwxr-xr-x
xsubpp
5.04
KB
-rwxr-xr-x
xvminitoppm
9.87
KB
-rwxr-xr-x
xwdtopnm
17.87
KB
-rwxr-xr-x
xz
78.5
KB
-rwxr-xr-x
xzcat
78.5
KB
-rwxr-xr-x
xzcmp
6.48
KB
-rwxr-xr-x
xzdiff
6.48
KB
-rwxr-xr-x
xzegrep
5.76
KB
-rwxr-xr-x
xzfgrep
5.76
KB
-rwxr-xr-x
xzgrep
5.76
KB
-rwxr-xr-x
xzless
1.76
KB
-rwxr-xr-x
xzmore
2.11
KB
-rwxr-xr-x
y2racc2.7
590
B
-rwxr-xr-x
ybmtopbm
9.87
KB
-rwxr-xr-x
yes
38.34
KB
-rwxr-xr-x
ypdomainname
26.23
KB
-rwxr-xr-x
yuvsplittoppm
9.87
KB
-rwxr-xr-x
yuvtoppm
9.87
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
5.76
KB
-rwxr-xr-x
zdump
26.21
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zeisstopnm
9.87
KB
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
211.19
KB
-rwxr-xr-x
zipcloak
91.62
KB
-rwxr-xr-x
zipdetails
49.53
KB
-rwxr-xr-x
zipgrep
2.88
KB
-rwxr-xr-x
zipinfo
182.29
KB
-rwxr-xr-x
zipnote
87.39
KB
-rwxr-xr-x
zipsplit
91.39
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : ucf
#!/bin/bash # -*- Mode: Sh -*- # updateConfFile.sh --- # Author : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) # Created On : Fri Feb 1 03:41:47 2002 # Created On Node : glaurung.green-gryphon.com # Last Modified By : Manoj Srivastava # Last Modified On : Tue Jun 6 09:48:22 2006 # Last Machine Used: glaurung.internal.golden-gryphon.com # Update Count : 186 # Status : Unknown, Use with caution! # HISTORY : # Description : # # This script attempts to provide conffile like handling for files not # shipped in a Debian package, but handled by the postinst. Using this # script, one may ship a bunch of default cofiguration files somewhere # in /usr (/usr/share/<pkg> is a good location), and maintain files in # /etc. # # The motivation for this script was to provide conffile like handling # for start files for emacs lisp packages (for example, # /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not # shipped with the package, instead, they are installed during the # post installation configuration phase by the script # /usr/lib/emacsen-common/emacs-package-install $package_name. # # This script is meant to be invoked by the packages install script at # /usr/lib/emacsen-common/packages/install/$package_name for each # flavour of installed emacsen by calling it with the proper values of # new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file # (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest. # # make sure we exit on error set -e # set the version and revision progname="$(basename $0)" pversion='Revision: 3.00 ' unset GREP_OPTIONS ###################################################################### ######## ######### ######## Utility functions ######### ######## ######### ###################################################################### setq() { # Variable Value Doc_string if [ "x$2" = "x" ]; then echo >&2 "$progname: Unable to determine $3" exit 1; else if [ "x$VERBOSE" != "x" ]; then echo >&2 "$progname: $3 is $2"; fi eval "$1=\"\$2\""; fi } # Usage: get_file_metadate file_name get_file_metadata() { if [ -e "$1" ]; then # get file modification date without the nanoseconds and timezone info local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))" # print file_name user.group permissions above_date stat --format "%n %U.%G 0%a $moddate" "$1" else echo "/dev/null" fi } # Runs the diff command with approrpiate arguments # Usage run_diff diff|sdiff diff_opts old_file new_file run_diff() { local diff_cmd="$1" local diff_opt="$2" local old_file="$3" local new_file="$4" # Note: get_file_metadata not in quotes to ignore "\n" characters local old_file_label=$(get_file_metadata "$old_file") local new_file_label=$(get_file_metadata "$new_file") [ -e "$old_file" ] || old_file=/dev/null [ -e "$new_file" ] || new_file=/dev/null if [ "$diff_cmd" = "diff" ] ; then diff "$diff_opt" --label "$old_file_label" "$old_file" \ --label "$new_file_label" "$new_file" || true elif [ "$diff_cmd" = "sdiff" ] ; then # unfortunatelly the sdiff command does not support --label option local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \ "$old_file_label" "$new_file_label" "$out" else echo "Unknown diff command: $diff_cmd" >&2 exit 1 fi } # Use debconf to show the differences # Usage: show_diff actual_file_differences file_stat_differences show_diff() { if [ -z "$1" ]; then DIFF="There are no non-white space differences in the files." else if [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then DIFF="The differences between the files are too large to display." else DIFF="$1" fi fi if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then templ=ucf/show_diff db_capb escape db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)" db_fset $templ seen false db_input critical $templ || true db_go || true db_get $templ # may contain sensitive information, so clear # immediatly after use so it is never written # to disk db_subst $templ DIFF "" db_reset $templ db_capb else if [ -z "$my_pager" ]; then echo "$DIFF" | sensible-pager else echo "$DIFF" | $my_pager fi fi } withecho () { echo "$@" >&2 "$@" } usageversion () { cat >&2 <<END Debian GNU/Linux $progname $pversion. Copyright (C) 2002-2005 Manoj Srivastava. This is free software; see the GNU General Public Licence for copying conditions. There is NO warranty. Usage: $progname [options] new_file destination Options: -h, --help print this message -s foo, --src-dir foo Set the src dir (historical md5sums live here) --sum-file bar Force the historical md5sums to be read from this file. Overrides any setting of --src-dir. -d[n], --debug=[n] Set the Debug level to N. Please note there must be no spaces before the debug level -n, --no-action Dry run. No action is actually taken. -v, --verbose Make the script verbose --three-way Register this file in the cache, and turn on the diff3 option allowing the merging of maintainer changes into a (potentially modified) local configuration file. ) --state-dir bar Set the state directory to bar instead of the default '/var/lib/ucf'. Used mostly for testing. --debconf-ok Indicate that it is ok for ucf to use an already running debconf instance for prompting. --debconf-template bar Specify an alternate, caller-provided debconf template to use for prompting. Usage: $progname -p destination -p, --purge Remove any reference to destination from records By default, the directory the new_file lives in is assumed to be the src-dir, which is where we look for any historical md5sums. END } ###################################################################### ######## ######### ######## file and hash save/restore functions ######### ######## ######### ###################################################################### purge_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 \ || true; fi #echo "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; if [ "X$docmd" = "XYES" ]; then mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" else echo mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" fi set -e fi fi test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file" if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then $action rm -f "$statedir/cache/$cached_file" fi } replace_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2; fi egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \ "$statedir/hashfile.tmp"; mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" set -e else echo "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\"" echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; " echo ") | sort > \"$statedir/hashfile\"" fi else if [ "X$docmd" = "XYES" ]; then md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" > \ "$statedir/hashfile" else echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \ "\"$statedir/hashfile\"" fi fi file_size=$(stat -c '%s' "$orig_new_file") if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then $action cp -pf "$orig_new_file" "$statedir/cache/$cached_file" fi # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" } replace_conf_file () { # do not mangle $dest_file since it's the one registered in the hashfile # or we have been ask to register real_file="$dest_file" if [ -L "$dest_file" ]; then real_file="$(readlink -nf $dest_file || :)" if [ "x$real_file" = "x" ]; then echo >&2 "$dest_file is a broken symlink!" $action rm -f "$dest_file"; real_file="$dest_file" fi fi if [ -e "$real_file" ]; then if [ -z "$RETAIN_OLD" ]; then #echo "Saving ${real_file}.${OLD_SUFFIX}, in case." if [ "x$VERBOSE" != "x" ]; then echo >&2 "Not saving ${real_file}, since it was unmodified" fi else $action cp -pf "${real_file}" "${real_file}.${OLD_SUFFIX}" fi fi $action cp -pf "$new_file" "${real_file}" replace_md5sum; } # Escape single quotes in the arguments passed in quote_single() { echo "$1" | sed -e "s,','\\\\'',g" } ###################################################################### ######## ######### ######## Command line args ######### ######## ######### ###################################################################### # # Long term variables# # docmd='YES' action='withecho' action= DEBUG=0 VERBOSE='' statedir='/var/lib/ucf'; THREEWAY= DIST_SUFFIX="ucf-dist" NEW_SUFFIX="ucf-new" OLD_SUFFIX="ucf-old" ERR_SUFFIX="merge-error" # save up the cmdline with proper quoting/escaping for arg in "$@"; do saved="${saved:+$saved }'$(quote_single "$arg")'" done # Note that we use `"$@"' to let each command-line parameter expand to a # separate word. The quotes around `$@' are essential! # We need TEMP as the `eval set --' would nuke the return value of getopt. TEMP=$(getopt -a -o hs:d::D::nv -n "$progname" \ --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \ -- "$@") # Note the quotes around `$TEMP': they are essential! eval set -- "$TEMP" while true ; do case "$1" in -h|--help) usageversion; exit 0 ;; -n|--no-action) action='echo'; docmd='NO'; shift ;; -v|--verbose) VERBOSE=1; shift ;; -s|--src-dir) opt_source_dir="$2"; shift 2 ;; --sum-file) opt_old_mdsum_file="$2"; shift 2 ;; --state-dir) opt_state_dir="$2"; shift 2 ;; --debconf-template) override_template="$2"; shift 2 ;; -D|-d|--debug|--DEBUG) # d has an optional argument. As we are in quoted mode, # an empty parameter will be generated if its optional # argument is not found. case "$2" in "") setq DEBUG 1 "The Debug value"; shift 2 ;; *) setq DEBUG "$2" "The Debug value"; shift 2 ;; esac ;; -p|--purge) PURGE=YES; shift ;; --three-way) THREEWAY=YES; shift ;; --debconf-ok) DEBCONF_OK=YES; shift ;; --) shift ; break ;; *) echo >&2 "Internal error!" ; exit 1 ;; esac done ###################################################################### ######## ######### ######## Sanity checking ######### ######## ######### ###################################################################### # Need to run as root, or else the if test "$(id -u)" != 0; then if [ "$docmd" = "YES" ]; then echo "$progname: Need to be run as root." >&2 echo "$progname: Setting up no action mode." >&2 action='echo'; docmd='NO'; fi fi if [ "X$PURGE" = "XYES" ]; then if [ $# != 1 ]; then echo >&2 "*** ERROR: Need exactly one argument when purging, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_dest_file="$1"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi else if [ $# != 2 ]; then echo >&2 "*** ERROR: Need exactly two arguments, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_new_file="$1"; temp_dest_file="$2"; if [ ! -e "${temp_new_file}" ]; then echo >&2 "Error: The new file ${temp_new_file} does not exist!"; exit 1; fi setq new_file "$(readlink -q -m $temp_new_file)" "The new file"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi fi safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"') ###################################################################### ######## ######### ######## Set Default Values ######### ######## ######### ###################################################################### # Load site defaults and over rides. if [ -f /etc/ucf.conf ]; then . /etc/ucf.conf fi # Command line, env variable, config file, or default if [ ! "x$opt_source_dir" = "x" ]; then setq source_dir "$opt_source_dir" "The Source directory" elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then setq source_dir "$UCF_SOURCE_DIR" "The Source directory" elif [ ! "x$conf_source_dir" = "x" ]; then setq source_dir "$conf_source_dir" "The Source directory" else if [ "X$new_file" != "X" ]; then setq source_dir "$(dirname $new_file)" "The Source directory" else setq source_dir "/tmp" "The Source directory" fi fi if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then my_pager="$(which $PAGER)"; elif [ -s /usr/bin/pager ] && [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then my_pager=/usr/bin/pager elif [ -x /usr/bin/sensible-pager ]; then my_pager=/usr/bin/sensible-pager elif [ -x /bin/more ]; then my_pager=/bin/more else my_pager= fi # Command line, env variable, config file, or default if [ ! "x$opt_state_dir" = "x" ]; then setq statedir "$opt_state_dir" "The State directory" elif [ ! "x$UCF_STATE_DIR" = "x" ]; then setq statedir "$UCF_STATE_DIR" "The State directory" elif [ ! "x$conf_state_dir" = "x" ]; then setq statedir "$conf_state_dir" "The State directory" else setq statedir '/var/lib/ucf' "The State directory" fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffold" = "x" ]; then setq force_conffold "$opt_force_conffold" "Keep the old file" elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file" elif [ ! "x$conf_force_conffold" = "x" ]; then setq force_conffold "$conf_force_conffold" "Keep the old file" else force_conffold='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffnew" = "x" ]; then setq force_conffnew "$opt_force_conffnew" "Replace the old file" elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file" elif [ ! "x$conf_force_conffnew" = "x" ]; then setq force_conffnew "$conf_force_conffnew" "Replace the old file" else force_conffnew='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffmiss" = "x" ]; then setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files" elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files" elif [ ! "x$conf_force_conffmiss" = "x" ]; then setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files" else force_conffmiss='' fi if [ -n "$opt_old_mdsum_file" ]; then setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here" elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here" elif [ ! "x$conf_old_mdsum_file" = "x" ]; then setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file" elif [ ! "x${new_file}" = "x" ]; then old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum"; else old_mdsum_file=""; fi ###################################################################### ######## ######### ######## More Sanity checking ######### ######## ######### ###################################################################### if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then echo >&2 "Error: Only one of force_conffold and force_conffnew should"; echo >&2 " be set"; exit 1; fi # VERBOSE of 0 is supposed to be the same as not setting VERBOSE if [ "X$VERBOSE" = "X0" ]; then VERBOSE='' fi # if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then echo >&2 "ucf: do not have write privilege to the state data" if [ "X$docmd" = "XYES" ]; then exit 1; fi fi if [ ! -d $statedir/cache ]; then $action mkdir -p $statedir/cache ; fi # test and see if this file exists in the database if [ -e "$statedir/hashfile" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "The hash file exists" echo >&2 egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true fi lastsum=$(egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \ awk '{print $1;}' ) fi if [ ! "x${new_file}" = "x" ]; then old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d"; else old_mdsum_dir=""; fi cached_file="$(echo $dest_file | tr / :)" ###################################################################### ######## ######### ######## Debugging dump ######### ######## ######### ###################################################################### if [ $DEBUG -gt 0 ]; then cat >&2 <<EOF The new start file is \`$new_file\' The destination is \`$dest_file\' (\`$safe_dest_file\') The history is kept under \'$source_dir\' The file may be cached at \'$statedir/cache/$cached_file\' EOF if [ -s "$dest_file" ]; then echo "The destination file exists, and has md5sum:" md5sum "$dest_file" else echo "The destination file does not exist." fi if [ "X$lastsum" != "X" ]; then echo "The old md5sum exists, and is:" echo "$lastsum" else echo "The old md5sum does not exist." if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then echo "However, there are historical md5sums around." fi fi if [ -e "$new_file" ]; then echo "The new file exists, and has md5sum:" md5sum "$new_file" else echo "The new file does not exist." fi if [ -d "$old_mdsum_dir" ]; then echo "The historical md5sum dir $old_mdsum_dir exists" elif [ -f "$old_mdsum_file" ]; then echo "The historical md5sum file $old_mdsum_file exists" else echo "Historical md5sums are not available" fi fi ###################################################################### ######## ######### ######## Short circuit if we are purging ######### ######## ######### ###################################################################### if [ "X$PURGE" = "XYES" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "Preparing to purge ${dest_file}" fi purge_md5sum; exit 0; fi # now we can restore $@ eval set -- "$saved" ###################################################################### ######## ######### ######## DebConf stuff ######### ######## ######### ###################################################################### # Is debconf already running? Kinda tricky, because it will be after the # confmodule is sourced, so only test before that. if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then if [ "$DEBIAN_HAS_FRONTEND" ]; then DEBCONF_ALREADY_RUNNING='YES' else DEBCONF_ALREADY_RUNNING='NO' fi fi export DEBCONF_ALREADY_RUNNING if [ -z "$DEBCONF_OK" ]; then if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then DEBCONF_OK='NO' else DEBCONF_OK='YES' fi fi # Time to start nagging the users who call ucf without debconf-ok if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then # Commented out for now, uncomment after a while to begin nagging # maintainers to fix their scripts. cat \ <<END *** WARNING: ucf was run from a maintainer script that uses debconf, but the script did not pass --debconf-ok to ucf. The maintainer script should be fixed to not stop debconf before calling ucf, and pass it this parameter. For now, ucf will revert to using old-style, non-debconf prompting. Ugh! Please inform the package maintainer about this problem. END fi # Start up debconf or at least get the db_* commands available if [ -e /usr/share/debconf/confmodule ]; then if test "$(id -u)" = 0; then . /usr/share/debconf/confmodule # Load our templates, just in case our template has # not been loaded or the Debconf DB lost or corrupted # since then, but only if it is OK to use debconf. if [ "$DEBCONF_OK" = 'YES' ]; then db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf fi else echo >&2 "$progname: Not loading confmodule, since we are not running as root." fi # Only set the title if debconf was not already running. # If it was running, then we do not want to clobber the # title used for configuring the whole package with debconf. if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then if ! db_settitle ucf/title 2>/dev/null; then # Older debconf that does not support that command. if test "$(id -u)" = 0; then db_title "Modified configuration file" else echo >&2 "$progname: Not changing title, since we are not running as root." fi fi fi fi ###################################################################### ######## ######### ######## Start Processing ######### ######## ######### ###################################################################### orig_new_file="$new_file" # Since sometimes we replace the newfile below newsum=$(md5sum "$new_file" | awk '{print $1}') # Determine the action for the current file. The default is to ask, # with non-replacement being the norm. # If the config dir exists # if file in always overwrite, state +=1; # fi # if file in never overwrite, state +=2; # fi # if file in ask; state +=4 # fi # if state == 0; then state = default # if state >= 4; ask # if state == 3; ask # if state == 2; exit # if state == 1; then replace_conffile; exit ###################################################################### ######## ######### ######## Do the replacement ######### ######## ######### ###################################################################### # Step 1: If we have no record of this file, and dest file # does, We need to determine how to initialize the # ${old_mdsum_prefix}.old file.. if [ -e "$dest_file" ]; then destsum=$(md5sum "$dest_file" | awk '{print $1}'); if [ "X$lastsum" = "X" ]; then # a: If we have a directory containing historical md5sums of this # file in question, we should look and see if the currently # installed file matches any of the old md5sums; in which case # it can be silently replaced. if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then if [ -d "$old_mdsum_dir" ]; then for file in ${old_mdsum_dir}/*; do oldsum="$(awk '{print $1}' $file)"; if [ "$oldsum" = "$destsum" ]; then if [ "X$force_conffold" = "X" ]; then # Bingo! replace, set the md5sum, and we are done if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi done elif [ -f "$old_mdsum_file" ]; then oldsum=$(egrep "^${destsum}" "$old_mdsum_file" || true) if [ "X$oldsum" != "X" ]; then # Bingo if [ "X$force_conffold" = "X" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi fi # Well, nothing matched. We now check to see if the # maintainer has an opinion on how to set the ``md5sum of the # previously installed version'', since we have no way of # determining that automatically. Please note that unless # there are limited number of previously released packages # (like just one), the maintainer is also making a guess at # this point by supplying a historical md5sum default file. if [ "X$VERBOSE" != "X" ]; then echo >&2 "Histotical md5sums did not match." fi if [ -d "$old_mdsum_dir" ]; then if [ -e "${old_mdsum_dir}/default" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "However, a default entry exists, using it." fi lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)" do_replace_md5sum=1; fi elif [ -f "$old_mdsum_file" ]; then oldsum=$(egrep "[[:space:]]default$" "$old_mdsum_file" | \ awk '{print $1;}') if [ "X$oldsum" != "X" ]; then # Bingo lastsum=$oldsum; do_replace_md5sum=1; fi fi fi # At this point, we are almost certain that either the # historical record of md5sums is not complete, or the user has # changed the configuration file. Rather than guessing and # chosing one of the historical md5sums, we fall through to the # solution used if there had been no historical md5sums # directory/file. if [ "X$lastsum" = "X" ]; then # b: We do not have a historical list of md5sums, or none # matched, and we still need to initialize the # ${old_mdsum_prefix}.old file. We can't determine whther or # not they made any changes, so we err on the side of caution # and ask' if [ "X$VERBOSE" != "X" ]; then echo >&2 "No match found, we shall ask." fi lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; fi # the old md5sum file does not exist, and the historical # record failed fi # the old md5sum file does not exist (bug)) else # "$dest_file" does not exist # Step 2: If destfile does not exist, create it, set the file # "${old_mdsum_prefix}.old" to the md5sum of the new file, and we # are done if [ "X$lastsum" = "X" ]; then # Ok, so there is no indication that the package was ever # installed on this machine. echo >&2 "" echo >&2 "Creating config file $dest_file with new version" replace_conf_file; exit 0; elif [ "$lastsum" = "$newsum" ]; then # OK, new version of the file is the same as the last version # we saw. Since the user apparently has deleted the file, # nothing needs be done, unless we have been told differently if [ "X$force_conffmiss" != "X" ]; then echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else echo >&2 "Not replacing deleted config file $dest_file"; fi else # OK. New upstream version. if [ "X$force_conffmiss" != "X" ]; then # User has said to replace missing files, so we do so, no # questions asked. echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else # Even though the user has deleted this file, they should # be asked now, unless specified otherwise. if [ "X$force_conffold" = "X" ]; then destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; else exit 0; fi fi fi fi # Here, the destfile exists. # step 3: If the old md5sum and the md5sum of the new file # do not match, we need to take action. if [ "$lastsum" = "$newsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums match, nothing needs be done." fi if [ "X$do_replace_md5sum" != "X" ]; then replace_md5sum; fi exit 0; # Hah. Match. We are done. fi # a: If the md5sum of the dest file is the same as lastsum, replace the # destfile, saying we are replacing old config files if [ "$destsum" = "$lastsum" ]; then if [ "X$force_conffold" = "X" ]; then echo >&2 "Replacing config file $dest_file with new version" replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi else # b: If the md5sum of the dest file differs from lastsum, we need to ask # the user what action to take. if [ "X$force_conffnew" != "X" ]; then echo >&2 "Replacing config file $dest_file with new version" echo >&2 "since you asked for it." if [ "$destsum" = "$newsum" ]; then echo >&2 "The new and the old files are identical, AFAICS" else echo >&2 "The new and the old files are different" fi replace_conf_file; exit 0; fi if [ "X$force_conffold" != "X" ]; then replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi # c: If the destination file is the same as the new maintianer provided one, # we need do nothing. if [ "$newsum" = "$destsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums of the file in place matches, nothing needs be done." fi replace_md5sum; exit 0; # Hah. Match. We are done. fi done='NO'; while [ "X$done" = "XNO" ]; do if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then # Use debconf to prompt. if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then templ=ucf/changeprompt_threeway else templ=ucf/changeprompt fi if [ "X$override_template" != "X" ]; then choices="$(db_metaget $templ Choices-C)" choices2="$(db_metaget $override_template Choices-C)" if [ "$choices" = "$choices2" ]; then templ=$override_template fi fi db_fset "$templ" seen false db_reset "$templ" db_subst "$templ" FILE "$dest_file" db_subst "$templ" NEW "$new_file" db_subst "$templ" BASENAME "$(basename $dest_file)" db_input critical "$templ" || true if ! db_go; then # The current ucf interface does not provide a way for it # to tell its caller that the user chose to back up. # However, we could get here, if the caller turned on # debconf's backup capb. The best thing to do seems to be # to ignore requests to back up. continue fi db_get "$templ" ANSWER="$RET" else echo >&2 "Need debconf to interact" exit 2 ######################################################################################## # # Prompt without using debconf. # # cat >&2 <<EOPRMT # # Configuration file \`$dest_file' # # ==> File on system created by you or by a script. # # ==> File also in package provided by package maintainer. # # What would you like to do about it ? Your options are: # # Y or I : install the package maintainer's version # # N or O : keep your currently-installed version # # D : show the differences between the versions # # S : show the side-by-side differences between the versions # # EOPRMT # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # cat >&2 <<EOTD # # 3 or T : show a three way difference between current, older, # # and new versions of the file # # M : Do a 3 way merge between current, older, # # and new versions of the file [Very Experimental] # # EOTD # # fi # # cat >&2 <<EOPEND # # Z : start a new shell to examine the situation # # The default action is to keep your current version. # # EOPEND # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/3/T/M/Z) [default=N] ?" # # else # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/Z) [default=N] ?" # # fi # # read -e ANSWER </dev/tty # ######################################################################################## fi case "$ANSWER" in install_new|y|Y|I|i) echo >&2 "Replacing config file $dest_file with new version" RETAIN_OLD=YES replace_conf_file; exit 0; ;; diff|D|d) DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" ;; sdiff|S|s) DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")" show_diff "$DIFF" ;; diff_threeway|3|t|T) if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then if [ -e "$dest_file" ]; then DIFF="$(diff3 -L Current -L Older -L New -A \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file")" || true else DIFF="$(diff3 -L Current -L Older -L New -A \ /dev/null "$statedir/cache/$cached_file" \ "$new_file")" || true fi show_diff "$DIFF" else DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" fi ;; merge_threeway|M|m) echo >&2 "Merging changes into the new version" if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then ret=0 diff3 -L Current -L Older -L New -m \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$? case "$ret" in 0) new_file="$dest_file.${NEW_SUFFIX}" RETAIN_OLD=YES replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 ;; *) mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}" db_subst ucf/conflicts_found dest_file "$dest_file" db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}" db_input critical ucf/conflicts_found || true db_go || true ;; esac else replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 fi ;; shell|Z|z) # We explicitly connect STDIN and STDOUT to the # script's controlling terminal, so even if STDIN is # fed by a pipe, as is the case when run from # /usr/bin/debconf, the shell should be fully # functional. However, the test for a controlling # terminal uses /usr/bin/tty, which consults only # STDIN. As far as I can tell, when run from debconf, # ucf will _never_ use the current terminal. If the # goal is to check for access to a terminal, the test # should be for foreground process group membership, # not a terminal connected to STDIN (tty -s), and not # a terminal it doesn't necessarily own (tty -s # </dev/tty). The easiest way do this from a shell is # probably with /bin/ps. if ps -o stat= --ppid $$ | grep -q '+'; then bash >/dev/tty </dev/tty || true elif [ -n "$DISPLAY" ]; then x-terminal-emulator || true else # Don't know what to do echo >&2 "No terminal, and no DISPLAY set, can't fork shell." sleep 3; fi ;; keep_current|n|N|o|O|'') replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; ;; *) if [ "$DEBCONF_OK" = "YES" ]; then echo "Error: unknown response from debconf:'$RET'" >&2 exit 1 else echo echo "Please answer with one of the single letters listed." >&2 echo fi esac done fi db_stop exit 0;
Close